module Backburner
  class RemoteCommand
    attr_accessor :command_stack

    def initialize command_name, connection, command_stack=nil
      @command_stack = command_stack || []
      @command_stack.unshift command_name
      @connection = connection
    end

    def method_missing method_name, *args
      self.class.new method_name, @command_stack
    end

    def flatten
      @command_stack.join ' '
    end

    %w{get set new del kill exit}.each do |method_name|

      define_method method_name do |*args|
        request_array = []
        request_array << method_name
        request_array << flatten
        case method_name
          when 'get' then
            request_array += args||[]
            @connection.cmd request_array.join(' ')
          when 'set' then
            @connection.send_text request_array.join(' '), args[0]
          when 'new' then
            request_array += args||[]
            @connection.cmd request_array.join(' ')
        end
      end

    end

  end
end